"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CardFooterSpacer = exports.CardFooter = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _designparams = require("../designparams");

var _padding = require("./padding");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * CardFooter
 *
 * The `CardFooter` component adds a small margin to all its children
 *
 * Note: the footer items are rendered from right to left!! This also causes the
 * focus to land on the most important button first. If focus behaviour needs to
 * be changed, please use tab-index or the order CSS property on the footer
 * children, as changing the order behaviour of the children will cause too much
 * breaking changes.
 */
var FOOTER_HEIGHT = '64px';

var CardFooter = _styledComponents.default.div.withConfig({
  displayName: "CardFooter",
  componentId: "sc-1h27g97-0"
})(["position:relative;display:flex;flex:none;flex-direction:row-reverse;align-items:center;justify-content:flex-start;padding:0 ", ";height:", ";> :not(:first-child){margin-right:", ";}"], _padding.CARD_PADDING, FOOTER_HEIGHT, _designparams.spacing.medium);

exports.CardFooter = CardFooter;

var CardFooterSpacer = _styledComponents.default.div.withConfig({
  displayName: "CardFooter__CardFooterSpacer",
  componentId: "sc-1h27g97-1"
})(["flex-grow:1;"]);

exports.CardFooterSpacer = CardFooterSpacer;