import { FC, Dispatch, SetStateAction } from 'react';
import { TranslationMeridiem } from './types';
interface TimePickerProps {
    /**
     * Current date value as date object
     */
    readonly date: Date;
    /**
     * Fires when date value is changed
     */
    readonly onChange: Dispatch<SetStateAction<Date>>;
}
/**
 * TimePickerTwentyFour
 *
 * Shows a clock component with 24 hour time options
 */
export declare const TimePickerTwentyFour: FC<TimePickerProps>;
interface TimePickerAMPMProps extends TimePickerProps {
    /**
     * AM/PM translation labels
     */
    readonly hour12MeridiemLabels: TranslationMeridiem;
}
/**
 * TimePickerAMPM
 *
 * Shows a clock component with AM/PM format.
 */
export declare const TimePickerAMPM: FC<TimePickerAMPMProps>;
/**
 * MinutePicker
 *
 * Shows a clock component with minute values
 */
export declare const MinutePicker: FC<TimePickerProps>;
export {};
