"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  Dialog: true,
  DialogProps: true
};
exports.Dialog = void 0;
Object.defineProperty(exports, "DialogProps", {
  enumerable: true,
  get: function get() {
    return _Dialog.DialogProps;
  }
});

var _BaseDialog = require("./BaseDialog");

Object.keys(_BaseDialog).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _BaseDialog[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _BaseDialog[key];
    }
  });
});

var _AlertDialog = require("./AlertDialog");

Object.keys(_AlertDialog).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _AlertDialog[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _AlertDialog[key];
    }
  });
});

var _ConfirmDialog = require("./ConfirmDialog");

Object.keys(_ConfirmDialog).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _ConfirmDialog[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _ConfirmDialog[key];
    }
  });
});

var _Dialog = require("./Dialog");

var _components = require("./components");

Object.keys(_components).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _components[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _components[key];
    }
  });
});

var _DialogMainSection = require("./components/DialogMainSection");

/* eslint-enable functional/prefer-readonly-type */
var DialogSetup = _Dialog.Dialog;
DialogSetup.CenteredSection = _DialogMainSection.CenteredSection;
DialogSetup.EdgeToEdgeSection = _DialogMainSection.EdgeToEdgeSection;
DialogSetup.ScrollSection = _DialogMainSection.ScrollSection;
DialogSetup.HeaderTitle = _Dialog.HeaderTitle;
var Dialog = DialogSetup;
exports.Dialog = Dialog;