import { FC, HTMLAttributes } from 'react';
import { IconType } from '../Icon';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = HTMLAttributes<BaseElement>;
export interface NoteProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * Used to input text.
     */
    readonly text: string;
    /**
     * The icon element.
     */
    readonly icon: IconType;
}
export declare const Note: FC<NoteProps>;
export {};
