import { HTMLAttributes, ReactNode } from 'react';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = HTMLAttributes<BaseElement>;
export interface PaperProps extends BaseProps {
    readonly children?: ReactNode;
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * If `true`, the corners become squared.
     */
    readonly square?: boolean;
    /**
     * If `true`, spacing is added.
     */
    readonly space?: boolean;
}
export declare const Paper: import("react").ForwardRefExoticComponent<PaperProps & import("react").RefAttributes<HTMLDivElement>>;
export {};
