"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RadioIconButton = RadioIconButton;
exports.RadioIconGroup = RadioIconGroup;
exports.RadioIconGroupField = void 0;

var _react = require("react");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _RadioButton = require("./RadioButton");

var _Icon = require("../Icon");

var _designparams = require("../designparams");

var _Typography = require("../Typography");

var _utils = require("../utils");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["label", "checked", "disabled", "onChange", "onValueChange", "icon", "onFocus", "onPointerUp", "onPointerDown"],
    _excluded2 = ["options", "name", "value", "onChange", "onValueChange", "error"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 *
 * The container for an icon.
 *
 */
var RadioIcon = _styledComponents.default.div.withConfig({
  displayName: "RadioIconButton__RadioIcon",
  componentId: "sc-17bvgob-0"
})(["position:relative;box-sizing:border-box;width:96px;height:80px;display:flex;align-items:center;justify-content:center;border-radius:", ";color:", ";", ";"], _designparams.shape.radius.medium, _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text05();
}, _ref2 => {
  var {
    theme,
    checked
  } = _ref2;
  return checked ? (0, _styledComponents.css)(["color:", ";background-color:", ";border:1px solid ", ";"], theme.color.elementPrimary(), theme.color.backgroundPrimary(), theme.color.elementPrimary()) : (0, _styledComponents.css)(["color:", ";background-color:", ";border:1px solid ", ";"], theme.color.text05(), theme.color.background02(), theme.color.element11());
});
/**
 *
 * The container for the entire button + icon + label,
 * with the input area as last child (catching events).
 *
 */


var RadioIconContainer = (0, _styledComponents.default)(_RadioButton.RadioContainer).withConfig({
  displayName: "RadioIconButton__RadioIconContainer",
  componentId: "sc-17bvgob-1"
})(["display:flex;align-items:center;flex-direction:column;", ";", ""], _ref3 => {
  var {
    theme,
    checked,
    visibleFocus
  } = _ref3;
  return checked ? (0, _styledComponents.css)(["&:hover ", "{color:", ";background-color:", ";border:1px solid ", ";}&:focus-within{outline:none;", "}&:active ", "{color:", ";background-color:", ";border:1px solid ", ";}"], RadioIcon, theme.color.textPrimary(), theme.color.elementPrimary(_designparams.opacity[16]), theme.color.elementPrimary(), visibleFocus ? (0, _styledComponents.css)(["", "{outline:none;color:", ";background-color:", ";border:2px solid ", ";}"], RadioIcon, theme.color.textPrimary(), theme.color.backgroundPrimary(), theme.color.textPrimary()) : undefined, RadioIcon, theme.color.textPrimary(), theme.color.elementPrimary(_designparams.opacity[24]), theme.color.textPrimary()) : (0, _styledComponents.css)(["&:hover ", "{color:", ";background-color:", ";border:1px solid ", ";}&:focus-within{outline:none;", "}&:active ", "{color:", ";background-color:", ";color:", ";}"], RadioIcon, theme.color.text04(), theme.color.background01(), theme.color.element11(), visibleFocus ? (0, _styledComponents.css)(["", "{outline:none;color:", ";background-color:", ";border:2px solid ", ";}"], RadioIcon, theme.color.text04(), theme.color.background02(), theme.color.textPrimary()) : undefined, RadioIcon, theme.color.text04(), theme.color.element11(_designparams.opacity[40]), theme.color.text04());
}, _ref4 => {
  var {
    disabled
  } = _ref4;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
});
/**
 *
 * The container for a label.
 *
 */

var RadioLabel = _styledComponents.default.div.withConfig({
  displayName: "RadioIconButton__RadioLabel",
  componentId: "sc-17bvgob-2"
})(["height:", ";display:flex;align-items:center;"], _designparams.componentSize.small);

function RadioIconButton(_ref5) {
  var {
    label,
    checked,
    disabled = false,
    onChange,
    onValueChange,
    icon,
    onFocus,
    onPointerUp,
    onPointerDown
  } = _ref5,
      rest = _objectWithoutProperties(_ref5, _excluded);

  var ref = /*#__PURE__*/(0, _react.createRef)();
  var pressed = (0, _reactHooksShareable.usePressed)(ref);
  var onChangeHandler = (0, _react.useCallback)(e => {
    onChange === null || onChange === void 0 ? void 0 : onChange(e);
    onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(e.target.value);
  }, [onChange, onValueChange]);
  var {
    isPointerOn,
    isPointerOff,
    determineVisibleFocus,
    visibleFocus
  } = (0, _reactHooksShareable.useVisibleFocus)();
  var handleFocus = (0, _react.useCallback)(e => {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
    determineVisibleFocus();
  }, [determineVisibleFocus, onFocus]);
  var handlePointerDown = (0, _react.useCallback)(e => {
    onPointerDown === null || onPointerDown === void 0 ? void 0 : onPointerDown(e);
    isPointerOn();
  }, [isPointerOn, onPointerDown]);
  var handlePointerUp = (0, _react.useCallback)(e => {
    onPointerUp === null || onPointerUp === void 0 ? void 0 : onPointerUp(e);
    isPointerOff();
  }, [isPointerOff, onPointerUp]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(RadioIconContainer, {
    disabled: disabled,
    checked: checked,
    partial: false,
    pressed: pressed,
    hovered: false,
    visibleFocus: visibleFocus,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(RadioIcon, {
      checked: checked,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.Icon, {
        icon: icon
      })
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(RadioLabel, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
        variant: "navigation-label",
        children: label
      })
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_RadioButton.RadioNative, _objectSpread({
      ref: ref,
      type: "radio",
      onChange: onChangeHandler,
      checked: checked,
      disabled: disabled,
      onPointerDown: handlePointerDown,
      onPointerUp: handlePointerUp,
      onFocus: handleFocus
    }, rest))]
  });
}
/*
 * Radio Icon Group
 */


var RadioIconGroupContainer = _styledComponents.default.div.withConfig({
  displayName: "RadioIconButton__RadioIconGroupContainer",
  componentId: "sc-17bvgob-3"
})(["display:flex;flex-direction:row;align-items:center;> ", ":not(:first-child){margin-left:48px;}"],
/* sc-selector */
RadioIconContainer);

function RadioIconGroup(_ref6) {
  var {
    options,
    name = '',
    value,
    onChange,
    onValueChange,
    error
  } = _ref6,
      rest = _objectWithoutProperties(_ref6, _excluded2);

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(RadioIconGroupContainer, _objectSpread(_objectSpread({}, rest), {}, {
    children: options.map((option, index) => /*#__PURE__*/(0, _jsxRuntime.jsx)(RadioIconButton, {
      name: name,
      value: option.value,
      label: option.label,
      disabled: option.disabled,
      checked: value === option.value,
      onChange: onChange,
      onValueChange: onValueChange,
      error: error,
      icon: option.icon
    }, index))
  }));
}

var RadioIconGroupField = props => (0, _utils.withField)(RadioIconGroup)(props);

exports.RadioIconGroupField = RadioIconGroupField;