"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseSelect = BaseSelect;
exports.SelectPopover = exports.SelectKeys = void 0;

var _react = require("react");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _Icon = require("../Icon");

var _icons = require("./icons");

var _designparams = require("../designparams");

var _Typography = require("../Typography");

var _utils = require("./utils");

var _PopOver = require("../PopOver");

var _utils2 = require("../PopOver/utils");

var _BaseSelectSelector = require("./BaseSelectSelector");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["anchorEl", "compact", "selectMarker", "direction", "align", "isOpen", "listRef", "options", "optionHandlers", "itemRefs", "valueIndex", "noOptionsLabel", "onScroll"],
    _excluded2 = ["value", "options", "onChange", "onBlur", "width", "compact", "selectMarker", "variant", "component", "disabled", "direction", "align", "error", "noOptionsLabel", "inline"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var SelectList = _styledComponents.default.ul.withConfig({
  displayName: "BaseSelect__SelectList",
  componentId: "sc-1c22wmr-0"
})(["display:block;padding:", " 0;margin:0;min-width:100%;height:100%;background-color:", ";box-shadow:", ";border-radius:", ";overflow:hidden auto;list-style:none;white-space:nowrap;font-family:", ";font-size:", ";line-height:", ";text-align:left;", ";"], _designparams.spacing.medium, _ref => {
  var {
    theme
  } = _ref;
  return theme.color.background05();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.shadow.selectList;
}, _designparams.shape.radius.medium, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.font.family;
}, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.font.size.regular;
}, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.font.lineHeight.large;
}, _ref6 => {
  var {
    align
  } = _ref6;
  return align === 'left' ? (0, _styledComponents.css)(["left:0;"]) : (0, _styledComponents.css)(["right:0;"]);
});

var SelectItem = _styledComponents.default.li.withConfig({
  displayName: "BaseSelect__SelectItem",
  componentId: "sc-1c22wmr-1"
})(["color:", ";min-height:", ";padding:0 ", ";display:flex;flex-direction:column;align-items:left;justify-content:center;cursor:pointer;", " ", ";"], _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.color.text01();
}, _ref8 => {
  var {
    compact
  } = _ref8;
  return compact ? _designparams.componentSize.small : _designparams.componentSize.medium;
}, _designparams.spacing.medium, _ref9 => {
  var {
    selected
  } = _ref9;
  return selected ? (0, _styledComponents.css)(["background-color:", ";"], _ref10 => {
    var {
      theme
    } = _ref10;
    return theme.color.background02();
  }) : undefined;
}, _ref11 => {
  var {
    disabled
  } = _ref11;
  return disabled ? (0, _styledComponents.css)(["cursor:default;color:", ";"], _ref12 => {
    var {
      theme
    } = _ref12;
    return theme.color.text05();
  }) : (0, _styledComponents.css)(["&:hover,&.arrow-select{background-color:", ";}&:active{outline:none;background-color:", ";}"], _ref13 => {
    var {
      theme
    } = _ref13;
    return theme.color.background02();
  }, _ref14 => {
    var {
      theme
    } = _ref14;
    return theme.color.background01();
  });
});

var Item = _styledComponents.default.span.withConfig({
  displayName: "BaseSelect__Item",
  componentId: "sc-1c22wmr-2"
})(["overflow:hidden;text-overflow:ellipsis;"]);

var NoOptionsText = (0, _styledComponents.default)(_Typography.Typography).withConfig({
  displayName: "BaseSelect__NoOptionsText",
  componentId: "sc-1c22wmr-3"
})(["display:flex;align-items:center;justify-content:center;color:", ";"], _ref15 => {
  var {
    theme
  } = _ref15;
  return theme.color.text01();
});
var CheckIcon = (0, _styledComponents.default)(_Icon.Icon).attrs({
  icon: _icons.SmallerCheckIcon
}).withConfig({
  displayName: "BaseSelect__CheckIcon",
  componentId: "sc-1c22wmr-4"
})(["color:", ";"], _ref16 => {
  var {
    theme
  } = _ref16;
  return theme.color.text05();
});

var CheckItemRow = _styledComponents.default.div.withConfig({
  displayName: "BaseSelect__CheckItemRow",
  componentId: "sc-1c22wmr-5"
})(["display:flex;align-items:center;", "{margin-right:", ";}"], CheckIcon, _designparams.spacing.medium);

var SelectOptionComponent = _ref17 => {
  var {
    value,
    disabled = false,
    onClick,
    compact,
    selectMarker,
    role,
    selected,
    itemRefs,
    index,
    component
  } = _ref17;
  var ref = (0, _react.useMemo)(() => el => el !== null ? itemRefs.current.set(index, el) : undefined, [itemRefs, index]); // We prevent default on pointer down to prevent the blur from happening
  // which would hide the menu before allowing us to click

  var handlePointerDown = (0, _react.useCallback)(e => e.preventDefault(), []);
  var item = selected && selectMarker === 'check' ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(CheckItemRow, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(CheckIcon, {}), component]
  }) : component;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(SelectItem, {
    value: value,
    disabled: disabled,
    onPointerDown: handlePointerDown,
    onClick: onClick,
    compact: compact,
    role: role,
    selected: selected && selectMarker === 'background',
    ref: ref,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(Item, {
      children: item
    })
  });
};

var SelectPopover = _ref18 => {
  var {
    anchorEl,
    compact: compactFromProps,
    selectMarker: selectMarkerFromProps,
    direction,
    align,
    isOpen,
    listRef,
    options,
    optionHandlers,
    itemRefs,
    valueIndex,
    noOptionsLabel,
    onScroll
  } = _ref18,
      props = _objectWithoutProperties(_ref18, _excluded);

  var {
    compact: compactFromTheme,
    selectMarker: selectMarkerFromTheme
  } = (0, _styledComponents.useTheme)();
  var compact = compactFromProps !== null && compactFromProps !== void 0 ? compactFromProps : compactFromTheme;
  var selectMarker = selectMarkerFromProps !== null && selectMarkerFromProps !== void 0 ? selectMarkerFromProps : selectMarkerFromTheme;
  var MAX_HEIGHT = 320;
  var MIN_HEIGHT = 160;
  var MAX_MIN_WIDTH = 300;
  var onDropdownPosition = (0, _react.useCallback)((anchorElement, popOverContainerEl) => {
    if ((listRef === null || listRef === void 0 ? void 0 : listRef.current) === null) {
      return;
    }

    var anchorBBox = anchorElement.getBoundingClientRect();
    var {
      top,
      bottom,
      left,
      right
    } = anchorBBox;
    popOverContainerEl.style.minWidth = "".concat(right - left, "px");
    popOverContainerEl.style.maxWidth = "".concat(Math.max(right - left, MAX_MIN_WIDTH), "px"); // Calculate available space above and below

    var {
      clientHeight
    } = document.documentElement;
    var spaceBelow = clientHeight - bottom - 16;
    var spaceAbove = top - 16;
    var nextDirection = direction; // Convert automatic direction to up or down

    if (nextDirection === 'auto') {
      // Doesn't fit below, more space above
      if (spaceBelow < MIN_HEIGHT && spaceAbove > spaceBelow) {
        nextDirection = 'up';
      } else {
        nextDirection = 'down';
      }
    } // Vertical position and alignment from up or down direction


    var verticalPosition = 'bottom';
    var verticalAlignment = 'top';
    var nextHeight = Math.min(spaceBelow, MAX_HEIGHT);

    if (nextDirection === 'up') {
      verticalPosition = 'top';
      verticalAlignment = 'bottom';
      nextHeight = Math.min(spaceAbove, MAX_HEIGHT);
      listRef.current.scrollTop = listRef.current.scrollHeight;
    } // Update height and position


    listRef.current.style.maxHeight = "".concat(nextHeight, "px");
    (0, _utils2.anchorPosition)(anchorElement, popOverContainerEl, {
      horizontalAlignment: align,
      horizontalPosition: align,
      verticalPosition,
      verticalAlignment
    });
  }, [align, direction, listRef]);

  if (!isOpen) {
    return null;
  }

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_PopOver.PopOver, _objectSpread(_objectSpread({
    anchorEl: anchorEl,
    onPosition: onDropdownPosition,
    onScroll: onScroll
  }, props), {}, {
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(SelectList, {
      align: align,
      role: "menu",
      ref: listRef,
      children: options.length === 0 && noOptionsLabel !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(NoOptionsText, {
        variant: "explanatory-text",
        children: noOptionsLabel
      }) : options.map((option, index) => /*#__PURE__*/(0, _jsxRuntime.jsx)(SelectOptionComponent, {
        value: option.value,
        disabled: option.disabled,
        onClick: optionHandlers[index],
        compact: compact,
        role: "menuitem",
        selected: index === valueIndex,
        selectMarker: selectMarker,
        component: option.component,
        itemRefs: itemRefs,
        index: index
      }, option.value))
    })
  }));
};

exports.SelectPopover = SelectPopover;

var SelectContainer = _styledComponents.default.div.withConfig({
  displayName: "BaseSelect__SelectContainer",
  componentId: "sc-1c22wmr-6"
})(["width:", ";"], _ref19 => {
  var {
    width
  } = _ref19;
  return (0, _utils.getWidth)(width);
});

var SelectKeys;
exports.SelectKeys = SelectKeys;

(function (SelectKeys) {
  SelectKeys["Space"] = " ";
  SelectKeys["ArrowUp"] = "ArrowUp";
  SelectKeys["ArrowDown"] = "ArrowDown";
  SelectKeys["Enter"] = "Enter";
  SelectKeys["Escape"] = "Escape";
  SelectKeys["Esc"] = "Esc";
})(SelectKeys || (exports.SelectKeys = SelectKeys = {}));

function BaseSelect(_ref20) {
  var {
    value,
    options,
    onChange,
    onBlur,
    width = 'full',
    compact: compactFromProps,
    selectMarker: selectMarkerFromProps,
    variant = 'filled',
    component,
    disabled = false,
    direction = 'auto',
    align = 'left',
    error = '',
    noOptionsLabel,
    inline
  } = _ref20,
      props = _objectWithoutProperties(_ref20, _excluded2);

  var {
    compact: compactFromTheme,
    selectMarker: selectMarkerFromTheme
  } = (0, _styledComponents.useTheme)();
  var compact = compactFromProps !== null && compactFromProps !== void 0 ? compactFromProps : compactFromTheme;
  var selectMarker = selectMarkerFromProps !== null && selectMarkerFromProps !== void 0 ? selectMarkerFromProps : selectMarkerFromTheme;
  var [isOpen, openPopover, closePopover, toggleOpen] = (0, _reactHooksShareable.useBoolean)(false);
  var [isKeyboard, setKeyboardOn, setKeyboardOff] = (0, _reactHooksShareable.useBoolean)(true);
  var [popupAnchorEl, setPopupAnchorEl] = (0, _react.useState)(null);
  var optionMap = (0, _react.useMemo)(() => {
    return new Map(options.map((option, index) => {
      return [option.value, _objectSpread(_objectSpread({}, option), {}, {
        index
      })];
    }));
  }, [options]);
  var valueOption = optionMap.get(value);
  var valueIndex = valueOption !== undefined ? valueOption.index : null;
  var optionHandlers = (0, _react.useMemo)(() => {
    return options.map(option => {
      return event => {
        event.stopPropagation();

        if (option.disabled === true) {
          return;
        }

        if (option.value !== value) {
          onChange === null || onChange === void 0 ? void 0 : onChange(option.value);
        }

        closePopover();
      };
    });
  }, [options, value, closePopover, onChange]);
  var arrowIndex = (0, _react.useRef)(null);
  var listRef = (0, _react.useRef)(null);
  var itemRefs = (0, _react.useRef)(new Map()); // In order to change selection with the keyboard,
  // we relay purely on DOM references, otherwise the
  // performance is horrible (freeze when keeping keys pressed).
  // For this, we use a 'arrow-select' class which is set on
  // the currently "selected" item (when using arrow keys).

  var moveArrowSelectIndex = (0, _react.useCallback)((fromIndex, toIndex) => {
    var itemRef = fromIndex !== null ? itemRefs.current.get(fromIndex) : undefined;
    var nextItemRef = toIndex !== null ? itemRefs.current.get(toIndex) : undefined;

    if (itemRef !== undefined) {
      itemRef.classList.remove('arrow-select');
    }

    if (nextItemRef !== undefined) {
      nextItemRef.classList.add('arrow-select');
      (0, _utils.scrollIntoView)(nextItemRef);
    }

    arrowIndex.current = toIndex;
  }, []);
  var handleKeyDown = (0, _react.useCallback)(event => {
    var {
      key
    } = event;

    if (!(key in SelectKeys)) {
      return;
    }

    if (key === SelectKeys.Escape || key === SelectKeys.Esc) {
      if (isOpen) {
        event.preventDefault();
        closePopover();
        setKeyboardOn();
      }

      return;
    }

    event.preventDefault();

    if (!isOpen) {
      arrowIndex.current = valueIndex;
      openPopover();
      return;
    }

    switch (key) {
      case SelectKeys.ArrowDown:
      case SelectKeys.ArrowUp:
        {
          var findIndex = key === SelectKeys.ArrowUp ? _utils.findPrevIndex : _utils.findNextIndex;
          var nextIndex = findIndex(arrowIndex.current, options);
          moveArrowSelectIndex(arrowIndex.current, nextIndex);
          break;
        }

      case SelectKeys.Enter:
        {
          if (arrowIndex.current === null) {
            closePopover();
            setKeyboardOn();
            break;
          }

          optionHandlers[arrowIndex.current](event);
          break;
        }
    }
  }, [isOpen, valueIndex, moveArrowSelectIndex, options, optionHandlers, closePopover, openPopover, setKeyboardOn]); // Scroll to the selected item on open.
  // useLayoutEffect is used here instead of useEffect so that
  // the scroll adjustment is synchronous (otherwise you see
  // it hop to the correct position)

  (0, _react.useLayoutEffect)(() => {
    if (!isOpen) {
      return undefined;
    }

    if (listRef.current === null) {
      return undefined;
    }

    var selectedItem = valueIndex !== null ? itemRefs.current.get(valueIndex) : undefined;

    if (selectedItem !== undefined) {
      (0, _utils.scrollIntoView)(selectedItem);
    }
  }, [isOpen, listRef, itemRefs, valueIndex]);
  var handleBlur = (0, _react.useCallback)(() => {
    onBlur === null || onBlur === void 0 ? void 0 : onBlur(true);
    setKeyboardOn();
    closePopover();
  }, [closePopover, onBlur, setKeyboardOn]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(SelectContainer, _objectSpread(_objectSpread({
    width: width,
    ref: setPopupAnchorEl,
    onBlur: handleBlur
  }, props), {}, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_BaseSelectSelector.BaseSelectSelector, {
      onToggleOpen: toggleOpen,
      open: isOpen,
      compact: compact,
      variant: variant,
      onKeyDown: handleKeyDown,
      onPointerDown: setKeyboardOff,
      hasError: error.length > 0,
      role: "button",
      tabIndex: 0,
      disabled: disabled,
      visibleFocus: isKeyboard,
      children: component
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(SelectPopover, {
      anchorEl: popupAnchorEl,
      onScroll: closePopover,
      compact: compact,
      selectMarker: selectMarker,
      direction: direction,
      align: align,
      onKeyDown: handleKeyDown,
      isOpen: isOpen,
      valueIndex: valueIndex,
      options: options,
      optionHandlers: optionHandlers,
      itemRefs: itemRefs,
      listRef: listRef,
      noOptionsLabel: noOptionsLabel,
      inline: inline
    })]
  }));
}