"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SliderField = exports.Slider = exports.Meta = void 0;

var _react = require("react");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _designparams = require("../designparams");

var _utils = require("../utils");

var _getXAbsolutePosition = require("./getXAbsolutePosition");

var _Tick = require("./Tick");

var _Typography = require("../Typography");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["value", "min", "max", "handleChange", "disabled", "className", "onKeyDown", "onClick", "onPointerDown", "onPointerUp", "onFocus", "tickConfig"],
    _excluded2 = ["key"],
    _excluded3 = ["label", "unitLabel"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var clamp = x => Math.max(0, Math.min(x, 1));

// Provides padding around the slider's track
var Container = _styledComponents.default.div.withConfig({
  displayName: "Slider__Container",
  componentId: "sc-qhogg2-0"
})(["box-sizing:border-box;display:grid;grid-auto-flow:row;padding:", ";width:100%;"], _designparams.spacing.medium); // The holder for the knob


var Rail = _styledComponents.default.div.withConfig({
  displayName: "Slider__Rail",
  componentId: "sc-qhogg2-1"
})(["position:absolute;height:2px;top:7px;left:8px;right:8px;background-color:", ";border-radius:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.element13();
}, _designparams.shape.radius.large); // Marks the position of the knob on the rail


var Trail = _styledComponents.default.div.withConfig({
  displayName: "Slider__Trail",
  componentId: "sc-qhogg2-2"
})(["background-color:", ";border-radius:", ";width:100%;height:100%;transform-origin:0px 0px;transition:", ";"], _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.elementPrimary();
}, _designparams.shape.radius.large, _ref3 => {
  var {
    pressed
  } = _ref3;
  return pressed ? 'none' : 'transform 0.2s ease-in-out';
}); // The handle for dragging the slider


var Knob = _styledComponents.default.div.withConfig({
  displayName: "Slider__Knob",
  componentId: "sc-qhogg2-3"
})(["width:", ";height:", ";position:absolute;top:-7px;left:0;border-radius:", ";transition:", ";&:hover{", "}"], _designparams.iconSize.small, _designparams.iconSize.small, _designparams.shape.radius.circle, _ref4 => {
  var {
    pressed
  } = _ref4;
  return pressed ? 'none' : 'transform 0.2s ease-in-out';
}, _ref5 => {
  var {
    fraction,
    theme
  } = _ref5;
  return fraction === 0 ? (0, _styledComponents.css)(["box-shadow:", ";"], theme.shadow.knobOff1) : (0, _styledComponents.css)(["box-shadow:", ";"], theme.shadow.knobOn2);
}); // The interaction part of the handle


var KnobCore = _styledComponents.default.svg.withConfig({
  displayName: "Slider__KnobCore",
  componentId: "sc-qhogg2-4"
})(["width:", ";height:", ";position:absolute;top:0;left:0;"], _designparams.iconSize.small, _designparams.iconSize.small); // Shows outline on KnobCore on focus


var KnobOutline = _styledComponents.default.svg.withConfig({
  displayName: "Slider__KnobOutline",
  componentId: "sc-qhogg2-5"
})(["width:", ";height:", ";position:absolute;top:0;left:0;stroke-width:2px;fill:transparent;stroke:transparent;"], _designparams.iconSize.small, _designparams.iconSize.small); // Shows user is currently engaging the knob


var KnobHalo = _styledComponents.default.div.withConfig({
  displayName: "Slider__KnobHalo",
  componentId: "sc-qhogg2-6"
})(["width:", ";height:", ";border-radius:", ";position:absolute;top:0;left:0;visibility:hidden;transition:transform 100ms;", ":hover &{visibility:unset;background-color:", ";transform:scale(2);}"], _designparams.iconSize.small, _designparams.iconSize.small, _designparams.shape.radius.circle,
/* sc-selector */
Knob, _ref6 => {
  var {
    fraction,
    theme
  } = _ref6;
  return fraction === 0 ? theme.color.element11(_designparams.opacity[16]) : theme.color.elementPrimary(_designparams.opacity[16]);
}); // Contains the track and knob, allows click to position


var Track = _styledComponents.default.div.withConfig({
  displayName: "Slider__Track",
  componentId: "sc-qhogg2-7"
})(["position:relative;width:100%;height:16px;cursor:pointer;", " ", ""], _ref7 => {
  var {
    fraction,
    visibleFocus,
    theme
  } = _ref7;
  return fraction === 0 ? (0, _styledComponents.css)(["", "{background-color:", ";}", "{box-shadow:", ";}", "{fill:", ";}", "{stroke:", ";stroke-width:1px;}&:focus{outline:none;", "}&:active{", "{box-shadow:", ";}", "{fill:", ";}", "{visibility:visible;background-color:", ";transform:scale(2.12);}", "{stroke:", ";stroke-width:1px;}}"], Rail, theme.color.element14(), Knob, theme.shadow.knobOff1, KnobCore, theme.color.element10(), KnobOutline, theme.color.element16(), visibleFocus ? (0, _styledComponents.css)(["", "{box-shadow:", ";}", "{fill:", ";}", "{visibility:visible;background-color:", ";transform:scale(2);}", "{stroke:", ";stroke-width:1px;}"], Knob, theme.shadow.knobOff1, KnobCore, theme.color.element10(), KnobHalo, theme.color.element11(_designparams.opacity[16]), KnobOutline, theme.color.textPrimary()) : undefined, Knob, theme.shadow.knobOff2, KnobCore, theme.color.element10(), KnobHalo, theme.color.element11(_designparams.opacity[24]), KnobOutline, theme.color.element16()) : (0, _styledComponents.css)(["", "{box-shadow:", ";}", "{fill:", ";}&:focus{outline:none;", "}&:active{", "{box-shadow:", ";}", "{fill:", ";}", "{visibility:visible;background-color:", ";transform:scale(2.12);}}"], Knob, theme.shadow.knobOn1, KnobCore, theme.color.elementPrimary(), visibleFocus ? (0, _styledComponents.css)(["", "{box-shadow:", ";}", "{fill:", ";}", "{visibility:visible;background-color:", ";transform:scale(2);}", "{stroke:", ";stroke-width:2px;}"], Knob, theme.shadow.knobOn2, KnobCore, theme.color.elementPrimary(), KnobHalo, theme.color.elementPrimary(_designparams.opacity[16]), KnobOutline, theme.color.textPrimary()) : undefined, Knob, theme.shadow.knobOn3, KnobCore, theme.color.textPrimary(), KnobHalo, theme.color.elementPrimary(_designparams.opacity[24]));
}, _ref8 => {
  var {
    disabled
  } = _ref8;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
});

var SliderKeys;

(function (SliderKeys) {
  SliderKeys["Home"] = "Home";
  SliderKeys["End"] = "End";
  SliderKeys["PageUp"] = "PageUp";
  SliderKeys["PageDown"] = "PageDown";
  SliderKeys["ArrowRight"] = "ArrowRight";
  SliderKeys["ArrowUp"] = "ArrowUp";
  SliderKeys["ArrowLeft"] = "ArrowLeft";
  SliderKeys["ArrowDown"] = "ArrowDown";
})(SliderKeys || (SliderKeys = {}));

var Meta = _styledComponents.default.div.withConfig({
  displayName: "Slider__Meta",
  componentId: "sc-qhogg2-8"
})(["position:relative;height:16px;"]);
/**
 * Slider component
 *
 * A horizontal track with a knob that can be moved
 * forward and backward. When the knob is pressed,
 * no transitions are applied, but when the track itself
 * is pressed, the knob jumps to the new position with
 * an animation.
 */

/**
 * TODO: according to UX, need to add `variant` property to have style `dashed`
 */


exports.Meta = Meta;

var Slider = _ref9 => {
  var {
    value,
    min = 0,
    max = 100,
    handleChange,
    disabled = false,
    className,
    onKeyDown,
    onClick,
    onPointerDown,
    onPointerUp,
    onFocus,
    tickConfig = {
      ticks: []
    }
  } = _ref9,
      props = _objectWithoutProperties(_ref9, _excluded);

  var sliderRef = (0, _react.useRef)(null);
  var knobRef = (0, _react.useRef)(null);
  var pressed = (0, _reactHooksShareable.usePressed)(knobRef);
  var [sliderWidth, setSliderWidth] = (0, _react.useState)(0); // Spread default values with incoming values since they are optional

  var {
    ticks,
    snap
  } = (0, _react.useMemo)(() => {
    return _objectSpread(_objectSpread({}, {
      snap: tickConfig.ticks.length > 0
    }), tickConfig);
  }, [tickConfig]);
  var fraction = (0, _react.useMemo)(() => clamp((value - min) / (max - min)), [max, min, value]); // Generate the ticks with its position along the x-axis

  var tickMarkers = (0, _react.useMemo)(() => ticks.map(v => {
    var _v$marker;

    return {
      position: (0, _getXAbsolutePosition.getXAbsolutePosition)(min, max, v.position),
      value: v.position,
      label: v.label,
      marker: (_v$marker = v.marker) !== null && _v$marker !== void 0 ? _v$marker : false
    };
  }), [max, min, ticks]);
  /**
   * To avoid making the calculation for snap values each time
   * the slider is dragged we create the snap values here.
   */

  var snapValues = (0, _react.useMemo)(() => tickMarkers.map(v => v.position / 100), [tickMarkers]);
  /** Convert from the slider track value format (0.0 - 1.0) to the format used by the value. */

  var convertDecimalToValue = (0, _react.useCallback)(x => min + (x !== null && x !== void 0 ? x : 0) * (max - min), [min, max]);
  var shouldSnapToTick = snap && tickMarkers.length > 0; // Computes the new value and passed it to the handleChange callback

  var handleClick = (0, _react.useCallback)(e => {
    e.preventDefault();
    onClick === null || onClick === void 0 ? void 0 : onClick(e);

    if (sliderRef.current !== null) {
      var {
        left,
        width
      } = sliderRef.current.getBoundingClientRect();
      var x = clamp((e.pageX - left) / width); // Find x position if snap is enabled

      if (e.type !== 'pointermove' && shouldSnapToTick) {
        var snapTo = snapValues.reduce((a, b) => Math.abs(b - x) < Math.abs(a - x) ? b : a);
        x = snapTo;
      }

      handleChange(convertDecimalToValue(x));
    }
  }, [handleChange, max, min, onClick, snap, snapValues, tickMarkers.length]); // Fetch slider dimensions once when the component is mounted and
  // again on each resize

  (0, _react.useEffect)(() => {
    var updateDims = () => {
      if (sliderRef.current !== null) {
        var {
          width
        } = sliderRef.current.getBoundingClientRect();
        setSliderWidth(width);
      }
    };

    if (sliderRef.current !== null) {
      updateDims();
      var observer = new window.ResizeObserver(updateDims);
      observer.observe(sliderRef.current);
    }
  }, []); // Track pointer position as soon as knob is pressed

  (0, _react.useEffect)(() => {
    if (pressed) {
      document.addEventListener('pointermove', handleClick);
      document.addEventListener('pointerup', handleClick);
      return () => {
        document.removeEventListener('pointermove', handleClick);
        document.removeEventListener('pointerup', handleClick);
      };
    }
  }, [handleClick, pressed]);
  var getNextSnap = (0, _react.useCallback)(() => snapValues.find(snapValue => snapValue > fraction), [snapValues, fraction]);
  var getPreviousSnap = (0, _react.useCallback)(() => snapValues.reverse().find(snapValue => snapValue < fraction), [snapValues, fraction]); // Keyboard support

  var handleKeyDown = (0, _react.useCallback)(event => {
    onKeyDown === null || onKeyDown === void 0 ? void 0 : onKeyDown(event);

    if (!(event.key in SliderKeys)) {
      return;
    }

    event.preventDefault();

    if (sliderRef.current !== null) {
      var {
        width
      } = sliderRef.current.getBoundingClientRect();
      setSliderWidth(width);
    }

    var onePercent = Math.abs((max - min) / 100);
    var newValue;

    switch (event.key) {
      case SliderKeys.ArrowRight:
      case SliderKeys.ArrowUp:
        {
          newValue = shouldSnapToTick ? convertDecimalToValue(getNextSnap()) : value + onePercent;
          break;
        }

      case SliderKeys.ArrowLeft:
      case SliderKeys.ArrowDown:
        {
          newValue = shouldSnapToTick ? convertDecimalToValue(getPreviousSnap()) : value - onePercent;
          break;
        }

      case SliderKeys.PageUp:
        {
          newValue = shouldSnapToTick ? convertDecimalToValue(getNextSnap()) : value + onePercent * 10;
          break;
        }

      case SliderKeys.PageDown:
        {
          newValue = shouldSnapToTick ? convertDecimalToValue(getPreviousSnap()) : value - onePercent * 10;
          break;
        }

      case SliderKeys.Home:
        {
          newValue = min;
          break;
        }

      case SliderKeys.End:
        {
          newValue = max;
          break;
        }

      default:
    } // keep new value inside min and max


    if (newValue !== undefined) {
      if (newValue > max) {
        newValue = max;
      } else if (newValue < min) {
        newValue = min;
      }

      handleChange(newValue);
    }
  }, [max, min, value, handleChange, onKeyDown]);
  var {
    isPointerOn,
    isPointerOff,
    determineVisibleFocus,
    visibleFocus
  } = (0, _reactHooksShareable.useVisibleFocus)();
  var handlePointerDown = (0, _react.useCallback)(e => {
    onPointerDown === null || onPointerDown === void 0 ? void 0 : onPointerDown(e);
    isPointerOn();
  }, [isPointerOn, onPointerDown]);
  var handlePointerUp = (0, _react.useCallback)(e => {
    onPointerUp === null || onPointerUp === void 0 ? void 0 : onPointerUp(e);
    isPointerOff();
  }, [isPointerOff, onPointerUp]);
  var handleFocus = (0, _react.useCallback)(e => {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
    determineVisibleFocus();
  }, [determineVisibleFocus, onFocus]);
  var tickLabels = (0, _react.useMemo)(() => {
    return tickMarkers.map((tick, index) => {
      return {
        key: index,
        label: tick.label,
        position: tick.position,
        value: tick.value,
        handleChange
      };
    });
  }, [handleChange, tickMarkers]);
  var hasTickLabels = (0, _react.useMemo)(() => tickLabels.length > 0, [tickLabels.length]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(Container, {
    className: className,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Track, _objectSpread(_objectSpread({
      onClick: handleClick,
      tabIndex: 0,
      onKeyDown: handleKeyDown,
      fraction: fraction,
      disabled: disabled,
      onPointerDown: handlePointerDown,
      onPointerUp: handlePointerUp,
      onFocus: handleFocus,
      visibleFocus: visibleFocus
    }, props), {}, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(Rail, {
        ref: sliderRef,
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Trail, {
          pressed: pressed,
          style: {
            transform: "scaleX(".concat(fraction, ")")
          }
        }), tickMarkers.map((tick, index) => /*#__PURE__*/(0, _jsxRuntime.jsx)(_Tick.TickMarker, {
          position: tick.position,
          marker: tick.marker
        }, index)), /*#__PURE__*/(0, _jsxRuntime.jsxs)(Knob, {
          fraction: fraction,
          pressed: pressed,
          style: {
            transform: "translateX(-50%) translateX(".concat(fraction * sliderWidth, "px)")
          },
          ref: knobRef,
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(KnobHalo, {
            fraction: fraction
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)(KnobCore, {
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)("circle", {
              cx: 8,
              cy: 8,
              r: 8
            })
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)(KnobOutline, {
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)("circle", {
              cx: 8,
              cy: 8,
              r: fraction === 0 ? 7.5 : 7
            })
          })]
        })]
      })
    })), hasTickLabels ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_Tick.TickLabelContainer, {
      children: tickLabels.map(_ref10 => {
        var {
          key
        } = _ref10,
            tickLabel = _objectWithoutProperties(_ref10, _excluded2);

        return /*#__PURE__*/(0, _jsxRuntime.jsx)(_Tick.TickLabel, _objectSpread({
          disabled: disabled
        }, tickLabel), key);
      })
    }) : null]
  });
};

exports.Slider = Slider;
var SliderLabel = (0, _styledComponents.default)(_utils.Label).withConfig({
  displayName: "Slider__SliderLabel",
  componentId: "sc-qhogg2-9"
})(["height:", ";"], _designparams.componentSize.mini); // Slider component has more air around its controls and will
// use smaller space between label and slider.

var SliderField = _ref11 => {
  var _props$disabled, _props$disabled2;

  var {
    label,
    unitLabel
  } = _ref11,
      props = _objectWithoutProperties(_ref11, _excluded3);

  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    children: [label !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(SliderLabel, {
      compact: false,
      disabled: (_props$disabled = props.disabled) !== null && _props$disabled !== void 0 ? _props$disabled : false,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
        variant: "navigation-label",
        children: label
      })
    }) : null, unitLabel !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(_utils.WithUnitLabelContainer, {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Slider, _objectSpread({}, props)), /*#__PURE__*/(0, _jsxRuntime.jsx)(_utils.Unit, {
        variant: "explanatory-text",
        disabled: (_props$disabled2 = props.disabled) !== null && _props$disabled2 !== void 0 ? _props$disabled2 : false,
        children: unitLabel
      })]
    }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(Slider, _objectSpread({}, props))]
  });
};

exports.SliderField = SliderField;