"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tab = Tab;
exports.TabBase = TabBase;
exports.VerticalTab = VerticalTab;

var _react = require("react");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Icon = require("../Icon");

var _designparams = require("../designparams");

var _Typography = require("../Typography");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["id", "selected", "disabled", "onSelect", "markerOffset", "children", "onKeyDown"],
    _excluded2 = ["id", "selected", "disabled", "icon", "onSelect", "markerOffset", "label"],
    _excluded3 = ["markerOffset"],
    _excluded4 = ["markerOffset"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// Constant size for Tab
var TAB_HEIGHT = '40px';
var MARKER_THICKNESS = '4px';
var FLEX_DIRECTION = {
  top: 'column-reverse',
  right: 'column-reverse',
  bottom: 'column-reverse',
  left: 'column-reverse'
};
/**
 * Tab container primitive
 */

var TabBaseContainer = _styledComponents.default.div.withConfig({
  displayName: "Tab__TabBaseContainer",
  componentId: "sc-14ckgxq-0"
})(["position:relative;display:flex;flex-direction:", ";height:", ";box-sizing:border-box;padding:", ";overflow:hidden;max-width:100%;user-select:none;color:", ";fill:", ";background-color:", ";opacity:", ";cursor:pointer;", ""], _ref => {
  var {
    markerOffset
  } = _ref;
  return FLEX_DIRECTION[markerOffset];
}, TAB_HEIGHT, _ref2 => {
  var {
    markerOffset
  } = _ref2;
  return markerOffset === 'left' || markerOffset === 'right' ? "0 ".concat(MARKER_THICKNESS) : "".concat(MARKER_THICKNESS, " 0");
}, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.text02();
}, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.element11();
}, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.color.background00();
}, _ref6 => {
  var {
    disabled
  } = _ref6;
  return disabled ? _designparams.opacity[48] : undefined;
}, _ref7 => {
  var {
    theme,
    selected,
    disabled
  } = _ref7;

  if (!selected && !disabled) {
    return (0, _styledComponents.css)(["&:hover{background-color:", ";}"], theme.color.background02());
  }

  if (selected) {
    return (0, _styledComponents.css)(["color:", ";fill:", ";background-color:", ";"], theme.color.elementPrimary(), theme.color.elementPrimary(), theme.color.backgroundPrimary());
  }
});
/**
 * Tab marker primitive
 */


// Renders a marker indicating that the tab is selected
var TabBaseMarker = _styledComponents.default.div.withConfig({
  displayName: "Tab__TabBaseMarker",
  componentId: "sc-14ckgxq-1"
})(["content:' ';position:absolute;flex:none;background-color:", ";transition:all 500ms cubic-bezier(0.57,0.67,0.015,1.005);", ""], _ref8 => {
  var {
    theme
  } = _ref8;
  return theme.color.elementAccent();
}, _ref9 => {
  var {
    offset,
    selected
  } = _ref9;
  return offset === 'left' || offset === 'right' ? (0, _styledComponents.css)(["width:", ";height:100%;", ":0;transform:", ";"], MARKER_THICKNESS, offset, selected ? 'scaleY(1)' : 'scaleY(0)') : (0, _styledComponents.css)(["height:", ";width:100%;", ":0;transform:", ";"], MARKER_THICKNESS, offset, selected ? 'scaleX(1)' : 'scaleX(0)');
});
/**
 * Tab contents primitive
 */


var TabBaseContents = _styledComponents.default.div.withConfig({
  displayName: "Tab__TabBaseContents",
  componentId: "sc-14ckgxq-2"
})(["width:100%;height:100%;overflow:hidden;"]);
/**
 *
 * Tab base
 *
 * A tab that is just a container for some content,
 * no icon/text is assumed and it's up to the user
 * to generate it. Use this if you need custom layout
 * for content inside the tab.
 *
 */


function TabBase(_ref10) {
  var {
    id,
    selected,
    disabled = false,
    onSelect,
    markerOffset = 'right',
    children,
    onKeyDown
  } = _ref10,
      props = _objectWithoutProperties(_ref10, _excluded);

  var onClick = (0, _react.useCallback)(() => {
    if (selected || disabled) {
      return;
    }

    onSelect(id);
  }, [selected, disabled, id, onSelect]);
  var handleKeyDown = (0, _react.useCallback)(event => {
    onKeyDown === null || onKeyDown === void 0 ? void 0 : onKeyDown(event);

    if (selected || disabled) {
      return;
    }

    if (event.key === 'Enter') {
      onSelect(id);
    }
  }, [selected, disabled, id, onSelect]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(TabBaseContainer, _objectSpread(_objectSpread({
    disabled: disabled,
    onClick: onClick,
    selected: selected,
    markerOffset: markerOffset,
    tabIndex: disabled ? undefined : 0,
    onKeyDown: handleKeyDown
  }, props), {}, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(TabBaseMarker, {
      offset: markerOffset,
      selected: selected
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(TabBaseContents, {
      children: children
    })]
  }));
}
/**
 *
 * Tab
 *
 * Tab base + quick setting of optional icon + label,
 * centered in the middle of the tab.
 * Use this if you need a default look for the tab
 * and only need icon/label inside the tab.
 *
 * There are two main components:
 *  - Tab (horizontal, marker top or bottom)
 *  - VerticalTab (vertical, marker left or right)
 *
 */

/**
 * Tab contents icon primitive
 */


var TabContentsIcon = (0, _styledComponents.default)(_Icon.Icon).withConfig({
  displayName: "Tab__TabContentsIcon",
  componentId: "sc-14ckgxq-3"
})(["flex:none;fill:inherit;"]);
/**
 * Tab contents label primitive
 */

var TabContentsLabel = _styledComponents.default.div.withConfig({
  displayName: "Tab__TabContentsLabel",
  componentId: "sc-14ckgxq-4"
})(["margin-left:", ";max-width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;pointer-events:none;color:inherit;font-weight:", ";"], _ref11 => {
  var {
    centered
  } = _ref11;
  return centered === true ? '0' : _designparams.spacing.medium;
}, _ref12 => {
  var {
    selected
  } = _ref12;
  return selected === true ? '600' : undefined;
});
/**
 * Tab contents primitive
 */


var TabContents = _styledComponents.default.div.withConfig({
  displayName: "Tab__TabContents",
  componentId: "sc-14ckgxq-5"
})(["height:100%;display:flex;align-items:center;justify-content:center;flex-grow:1;overflow:hidden;padding:0 ", ";"], _designparams.spacing.medium);
/**
 * Tab primitive
 */


function InternalTab(_ref13) {
  var {
    id,
    selected = false,
    disabled = false,
    icon,
    onSelect,
    markerOffset,
    label
  } = _ref13,
      props = _objectWithoutProperties(_ref13, _excluded2);

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(TabBase, _objectSpread(_objectSpread({
    id: id,
    disabled: disabled,
    onSelect: onSelect,
    selected: selected,
    markerOffset: markerOffset
  }, props), {}, {
    children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(TabContents, {
      children: [icon !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(TabContentsIcon, {
        icon: icon
      }) : null, /*#__PURE__*/(0, _jsxRuntime.jsx)(TabContentsLabel, {
        selected: selected,
        centered: icon === undefined,
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
          variant: "navigation-label",
          children: label
        })
      })]
    })
  }));
}
/**
 * Tab
 */


function Tab(_ref14) {
  var {
    markerOffset = 'bottom'
  } = _ref14,
      props = _objectWithoutProperties(_ref14, _excluded3);

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(InternalTab, _objectSpread(_objectSpread({}, props), {}, {
    markerOffset: markerOffset
  }));
}
/**
 * Vertical tab
 */


function VerticalTab(_ref15) {
  var {
    markerOffset = 'right'
  } = _ref15,
      props = _objectWithoutProperties(_ref15, _excluded4);

  return /*#__PURE__*/(0, _jsxRuntime.jsx)(InternalTab, _objectSpread(_objectSpread({}, props), {}, {
    markerOffset: markerOffset
  }));
}