import { FC, ReactNode } from 'react';
import { SimpleToastsDurations } from './useToasts';
export interface ToastsPlacement {
    readonly justify: 'center' | 'right';
    readonly top: string;
}
interface ToastsProviderProps extends SimpleToastsDurations {
    readonly children?: ReactNode;
}
interface ToastTransitionProps {
    readonly children?: ReactNode;
}
/**
 *
 * Toasts provider
 *
 * Used to provide a context for dispatching toast actions.
 *
 * Note: Do not use this directly! Instead use the `useToasts` hook which wraps
 * the dispatch ref.
 *
 */
export declare const ToastsProvider: FC<ToastsProviderProps>;
export declare const ToastTransition: FC<ToastTransitionProps>;
export interface ToastsAnchorProps {
    /**
     * Where the toasts should be placed.
     *
     * Default: top right
     */
    readonly placement: ToastsPlacement;
}
export declare const ToastsAnchor: FC<ToastsAnchorProps>;
export {};
